'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var documenter = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(options) {
    var _this = this;

    var pack, headers, tarball, metadata, readme, docs, files, gzip, tgz, output;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            headers = function headers(name, dir) {
              dir = dir || '';
              return { name: path.join(options.project, dir, name) };
            };

            options = _.defaults({}, options, {
              credentials: {},
              project: null,
              tier: null,
              schemas: {},
              menuIndex: 10,
              docsFolder: rootdir.get() + '/docs',
              references: [],
              publish: process.env.NODE_ENV == 'production'
            });

            assert(options.schemas, 'options.schemas must be given');
            assert(options.tier, 'options.tier must be given');
            assert(['core', 'platform'].indexOf(options.tier) !== -1, 'options.tier is either core or platform');

            if (!options.project) {
              pack = require(path.join(rootdir.get(), 'package.json'));

              options.project = pack.name;
            }

            tarball = tar.pack();
            metadata = {
              version: 1,
              tier: options.tier,
              menuIndex: options.menuIndex
            };


            tarball.entry(headers('metadata.json'), (0, _stringify2.default)(metadata, null, 2));

            _.forEach(options.schemas, function (schema, name) {
              var data = (0, _stringify2.default)(schema, null, 2);
              tarball.entry(headers(name, 'schema'), data);
            });

            _.forEach(options.references, function (reference) {
              var data = (0, _stringify2.default)(reference.reference, null, 2);
              tarball.entry(headers(reference.name + '.json', 'references'), data);
            });

            _context3.prev = 11;
            _context3.next = 14;
            return fs.readFile(path.join(rootdir.get(), 'README.md'));

          case 14:
            readme = _context3.sent;

            tarball.entry(headers('README.md'), readme);
            _context3.next = 23;
            break;

          case 18:
            _context3.prev = 18;
            _context3.t0 = _context3['catch'](11);

            if (!(_context3.t0.code !== 'ENOENT')) {
              _context3.next = 22;
              break;
            }

            throw _context3.t0;

          case 22:
            debug('README.md does not exist.');

          case 23:
            if (!options.docsFolder) {
              _context3.next = 36;
              break;
            }

            _context3.prev = 24;
            docs = options.docsFolder;
            files = recursiveReadSync(options.docsFolder);
            _context3.next = 29;
            return _promise2.default.all(files.map(function () {
              var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(file) {
                var relativePath, data;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        relativePath = path.basename(file);
                        _context.next = 3;
                        return fs.readFile(file, { encoding: 'utf8' });

                      case 3:
                        data = _context.sent;

                        tarball.entry(headers(relativePath, 'docs'), data);

                      case 5:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 29:
            _context3.next = 36;
            break;

          case 31:
            _context3.prev = 31;
            _context3.t1 = _context3['catch'](24);

            if (!(_context3.t1.code !== 'ENOENT')) {
              _context3.next = 35;
              break;
            }

            throw _context3.t1;

          case 35:
            debug('Docs folder does not exist');

          case 36:

            // the stream was added
            // no more entries
            tarball.finalize();

            gzip = zlib.createGzip();
            tgz = tarball.pipe(gzip);

            if (!options.publish) {
              _context3.next = 41;
              break;
            }

            return _context3.delegateYield(_regenerator2.default.mark(function _callee2() {
              var auth, creds, s3, s3Stream, upload, uploadPromise;
              return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      auth = new client.Auth({
                        credentials: options.credentials
                      });
                      _context2.next = 3;
                      return auth.awsS3Credentials('read-write', 'taskcluster-raw-docs', options.project + '/');

                    case 3:
                      creds = _context2.sent;
                      s3 = new aws.S3(creds.credentials);
                      s3Stream = S3UploadStream(s3);
                      upload = s3Stream.upload({
                        Bucket: 'taskcluster-raw-docs',
                        Key: options.project + '/latest.tar.gz'
                      });

                      // handle progress

                      upload.on('part', function (details) {
                        debug(details);
                      });

                      uploadPromise = new _promise2.default(function (resolve, reject) {
                        // handle upload completion
                        upload.on('uploaded', function (details) {
                          debug(details);
                          resolve(details);
                        });

                        // handle errors
                        upload.on('error', function (error) {
                          console.log(error.stack);
                          reject(error);
                        });
                      });

                      // pipe the incoming filestream through compression and up to s3

                      tgz.pipe(upload);
                      _context2.next = 12;
                      return uploadPromise;

                    case 12:
                    case 'end':
                      return _context2.stop();
                  }
                }
              }, _callee2, _this);
            })(), 't2', 41);

          case 41:
            output = {
              tgz: tgz
            };
            return _context3.abrupt('return', output);

          case 43:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this, [[11, 18], [24, 31]]);
  }));

  return function documenter(_x) {
    return _ref.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tar = require('tar-stream');
var _ = require('lodash');
var assert = require('assert');
var fs = require('mz/fs');
var path = require('path');
var recursiveReadSync = require('recursive-readdir-sync');
var zlib = require('zlib');
var rootdir = require('app-root-dir');
var aws = require('aws-sdk');
var client = require('taskcluster-client');
var S3UploadStream = require('s3-upload-stream');
var debug = require('debug')('taskcluster-lib-docs');

module.exports = documenter;
//# sourceMappingURL=docs.js.map
